Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman1.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman1.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman1.cs	(revision 17642)
@@ -1,30 +1,45 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman1 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.6.2a f = exp(-theta^2/2)/sqrt(2*pi)"; } }
+  public class Feynman1 : FeynmanDescriptor {
+    private readonly int trainingSamples;
+    private readonly int testSamples;
 
- protected override string TargetVariable { get { return "f"; } }
-    protected override string[] VariableNames { get { return new string[] { "theta", "f" }; } }
-    protected override string[] AllowedInputVariables { get { return new string[] { "theta" }; } }
+    public override string Name {
+      get { return string.Format("Feynman I.6.2a exp(-theta**2/2)/sqrt(2*pi) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "f"; } }
+    protected override string[] VariableNames { get { return new[] {"theta", "f"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"theta"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman1() : this((int)System.DateTime.Now.Ticks) { }
+    public Feynman1() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
 
     public Feynman1(int seed) {
-      Seed = seed;
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
     }
 
+    public Feynman1(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
+
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
+      var data  = new List<List<double>>();
       var theta = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 3).ToList();
 
@@ -34,5 +49,4 @@
       data.Add(f);
 
-
       for (var i = 0; i < theta.Count; i++) {
         var res = Math.Exp(Math.Pow(-theta[i], 2) / 2) / Math.Sqrt(2 * Math.PI);
@@ -40,5 +54,4 @@
       }
 
-
       return data;
     }
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman10.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman10.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman10.cs	(revision 17642)
@@ -1,35 +1,49 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman10 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.12.2 F = q1*q2*r/(4*pi*epsilon*r^3)"; } }
+  public class Feynman10 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "F"; } }
-    protected override string[] VariableNames { get { return new string[] { "q1", "q2", "epsilon", "r", "F"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"q1", "q2", "epsilon", "r"}; } }
+    public Feynman10() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman10(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman10(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.12.2 q1*q2*r/(4*pi*epsilon*r**3) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "F"; } }
+    protected override string[] VariableNames { get { return new[] {"q1", "q2", "epsilon", "r", "F"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"q1", "q2", "epsilon", "r"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman10() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman10(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
-      var q1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var q2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var data    = new List<List<double>>();
+      var q1      = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var q2      = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
       var epsilon = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var r = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-
+      var r       = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var F = new List<double>();
@@ -46,5 +60,4 @@
       }
 
-
       return data;
     }
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman100.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman100.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman100.cs	(revision 17642)
@@ -6,5 +6,24 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
   public class Feynman100 : FeynmanDescriptor {
-    public override string Name { get { return "Feynman III.21.20 -rho_c_0*q*A_vec/m"; } }
+    private readonly int testSamples;
+    private readonly int trainingSamples;
+
+    public Feynman100() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman100(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman100(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman III.21.20 -rho_c_0*q*A_vec/m | {0} samples", trainingSamples); }
+    }
 
     protected override string TargetVariable { get { return "j"; } }
@@ -14,9 +33,8 @@
     public int Seed { get; private set; }
 
-    public Feynman100() : this((int) DateTime.Now.Ticks) { }
-
-    public Feynman100(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman11.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman11.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman11.cs	(revision 17642)
@@ -1,34 +1,48 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman11 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.12.4 Ef = q1*r/(4*pi*epsilon*r^3)"; } }
+  public class Feynman11 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "Ef"; } }
-    protected override string[] VariableNames { get { return new string[] { "q1", "epsilon", "r", "Ef"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"q1", "epsilon", "r"}; } }
+    public Feynman11() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman11(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman11(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.12.4 q1*r/(4*pi*epsilon*r**3) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "Ef"; } }
+    protected override string[] VariableNames { get { return new[] {"q1", "epsilon", "r", "Ef"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"q1", "epsilon", "r"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman11() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman11(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
-      var q1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var data    = new List<List<double>>();
+      var q1      = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
       var epsilon = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var r = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-
+      var r       = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var Ef = new List<double>();
@@ -44,5 +58,4 @@
       }
 
-
       return data;
     }
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman12.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman12.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman12.cs	(revision 17642)
@@ -1,32 +1,45 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman12 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.12.5 F = q2*Ef"; } }
+  public class Feynman12 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "F"; } }
-    protected override string[] VariableNames { get { return new string[] { "q2", "Ef", "F"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"q2", "Ef"}; } }
+    public Feynman12() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman12(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman12(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name { get { return string.Format("Feynman I.12.5 q2*Ef | {0} samples", trainingSamples); } }
+
+    protected override string TargetVariable { get { return "F"; } }
+    protected override string[] VariableNames { get { return new[] {"q2", "Ef", "F"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"q2", "Ef"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman12() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman12(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var q2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var Ef = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var q2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var Ef   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var F = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman13.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman13.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman13.cs	(revision 17642)
@@ -1,34 +1,49 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman13 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.12.11 F = q*(Ef+B*v*sin(theta))"; } }
+  public class Feynman13 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "F"; } }
-    protected override string[] VariableNames { get { return new string[] { "q", "Ef", "B", "v", "theta", "F"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"q", "Ef", "B", "v", "theta"}; } }
+    public Feynman13() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman13(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman13(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.12.11 q*(Ef+B*v*sin(theta)) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "F"; } }
+    protected override string[] VariableNames { get { return new[] {"q", "Ef", "B", "v", "theta", "F"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"q", "Ef", "B", "v", "theta"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman13() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman13(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
-      var q = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var Ef = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var B = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var v = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var data  = new List<List<double>>();
+      var q     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var Ef    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var B     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var v     = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
       var theta = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman14.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman14.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman14.cs	(revision 17642)
@@ -1,36 +1,50 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman14 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.13.12 U = G*m1*m2*(1/r2-1/r1)"; } }
+  public class Feynman14 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "U"; } }
-    protected override string[] VariableNames { get { return new string[] { "m1", "m2", "r1", "r2", "G", "U"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"m1", "m2", "r1", "r2", "G"}; } }
+    public Feynman14() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman14(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman14(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.13.12 G*m1*m2*(1/r2-1/r1) | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "U"; } }
+    protected override string[] VariableNames { get { return new[] {"m1", "m2", "r1", "r2", "G", "U"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"m1", "m2", "r1", "r2", "G"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman14() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman14(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var m1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var m2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var r1 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var r2 = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var G = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-
+      var m1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var m2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var r1   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var r2   = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var G    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var U = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman15.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman15.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman15.cs	(revision 17642)
@@ -1,33 +1,46 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman15 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.14.3 U = m*g*z"; } }
+  public class Feynman15 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "U"; } }
-    protected override string[] VariableNames { get { return new string[] { "m", "g", "z", "U"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"m", "g", "z"}; } }
+    public Feynman15() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman15(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman15(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name { get { return string.Format("Feynman I.14.3 m*g*z | {0} samples", trainingSamples); } }
+
+    protected override string TargetVariable { get { return "U"; } }
+    protected override string[] VariableNames { get { return new[] {"m", "g", "z", "U"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"m", "g", "z"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman15() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman15(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
       var data = new List<List<double>>();
-      var m = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var g = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var z = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var m    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var g    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var z    = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var U = new List<double>();
Index: branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman16.cs
===================================================================
--- branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman16.cs	(revision 17641)
+++ branches/3075_aifeynman_instances/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Feynman/Feynman16.cs	(revision 17642)
@@ -1,32 +1,47 @@
-﻿using System;
+using System;
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
-using HeuristicLab.Common;
 using HeuristicLab.Random;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Feynman16 : FeynmanDescriptor{
- public override string Name { get { return "Feynman I.14.4 U = 1/2*k_spring*x^2"; } }
+  public class Feynman16 : FeynmanDescriptor {
+    private readonly int testSamples;
+    private readonly int trainingSamples;
 
- protected override string TargetVariable { get { return "U"; } }
-    protected override string[] VariableNames { get { return new string[] { "k_spring", "x", "U"}; } }
-    protected override string[] AllowedInputVariables { get { return new string[] {"k_spring", "x"}; } }
+    public Feynman16() : this((int) DateTime.Now.Ticks, 10000, 10000) { }
+
+    public Feynman16(int seed) {
+      Seed            = seed;
+      trainingSamples = 10000;
+      testSamples     = 10000;
+    }
+
+    public Feynman16(int seed, int trainingSamples, int testSamples) {
+      Seed                 = seed;
+      this.trainingSamples = trainingSamples;
+      this.testSamples     = testSamples;
+    }
+
+    public override string Name {
+      get { return string.Format("Feynman I.14.4 1/2*k_spring*x**2 | {0} samples", trainingSamples); }
+    }
+
+    protected override string TargetVariable { get { return "U"; } }
+    protected override string[] VariableNames { get { return new[] {"k_spring", "x", "U"}; } }
+    protected override string[] AllowedInputVariables { get { return new[] {"k_spring", "x"}; } }
 
     public int Seed { get; private set; }
 
-    public Feynman16() : this((int)System.DateTime.Now.Ticks) { }
-
-    public Feynman16(int seed) {
-      Seed = seed;
-    }
+    protected override int TrainingPartitionStart { get { return 0; } }
+    protected override int TrainingPartitionEnd { get { return trainingSamples; } }
+    protected override int TestPartitionStart { get { return trainingSamples; } }
+    protected override int TestPartitionEnd { get { return trainingSamples + testSamples; } }
 
     protected override List<List<double>> GenerateValues() {
-      var rand = new MersenneTwister((uint)Seed);
+      var rand = new MersenneTwister((uint) Seed);
 
-      var data = new List<List<double>>();
+      var data     = new List<List<double>>();
       var k_spring = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
-      var x = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
+      var x        = ValueGenerator.GenerateUniformDistributedValues(rand.Next(), TestPartitionEnd, 1, 5).ToList();
 
       var U = new List<double>();
